// Header File
// Created 4/22/2004; 11:13:02 PM
    void* allocated[100];
    unsigned short num_allocated=0;
#define CURRENT_INCY 30
unsigned short CalcBitmapSize(BITMAP *b)
{
  return ((((b->NumCols + 7) >> 3) * b->NumRows) + BITMAP_HDR_SIZE);
}
void	BitmapGettt(SCR_RECT *rect, void *bitmap,void* CURRENT_SCREEN)
{
short* BitMap=bitmap;
	short x, y, h, w, bytewidth;
	unsigned char* dest;
	unsigned short FinalMask;
	
	BitmapInit(rect, BitMap);
	x = rect->xy.x0;
	y = rect->xy.y0;
	h = rect->xy.y1 - rect->xy.y0 + 1;
	w = rect->xy.x1 - rect->xy.x0 + 1;
	FinalMask = (0xFF >> (8-(w&7))) << (8-(w&7));
	bytewidth = /*((w-1)>>3)+1*/ (w+7) >> 3;
	dest = (unsigned char *) ((short *) BitMap+2);
	{
	    register unsigned char* addr  = (CURRENT_SCREEN)+(y*30+(x>>3));
	    register unsigned short mask1 = x & 7;
	    register unsigned short mask2;
	    register unsigned short lineoffset = 30-bytewidth;
	    register          short loop;
	
	        {
	        mask2 = 8 - mask1;
	        for (;h;h--,addr+=lineoffset)
	            {
	            *dest = (*addr++) << mask1;
	            for (loop=1;loop<bytewidth;loop++)
	               {
	               *dest++ |= (*addr >> mask2);
	               *dest = (*addr++) << mask1;
	               }
	            *dest|=*addr>>mask2;
	            dest++;
	            }
	            return;
	         }
	}
}


void SpriteX8_or(short x,short y,short h,unsigned char* sprite,short bytewidth,void* dest) {
    register unsigned char* addr  = ((unsigned char*)dest)+(CURRENT_INCY*y+(x>>3));
    register unsigned short mask1 = x & 7; 
    register unsigned short mask2; 
    register unsigned short lineoffset = CURRENT_INCY-bytewidth; 
    register          short loop; 
    if (mask1) { 
        mask2 = 8 - mask1; 
        for (;h;h--,addr+=lineoffset) { 
            *addr++ |= *sprite >> mask1; 
            for (loop=1;loop<bytewidth;loop++) { 
               *addr |= ((*sprite++) << mask2); 
               *addr++ |= (*sprite >> mask1); 
            } 
            *addr |= (*sprite++ << mask2); 
        } 
    } else { 
        for (;h;h--,addr+=lineoffset) { 
            for (loop=0;loop<bytewidth;loop++) *addr++ |= *sprite++;
        } 
    }
}

void SpriteX8_and(short x,short y,short h,unsigned char* sprite,short bytewidth,void* dest) {
    register unsigned char* addr  = ((unsigned char*)dest)+(CURRENT_INCY*y+(x>>3));
    register unsigned short mask1 = x & 7; 
    register unsigned short mask2; 
    register unsigned short lineoffset = CURRENT_INCY-bytewidth; 
    register          short loop; 
    if (mask1) { 
        mask2 = 8 - mask1; 
        for (;h;h--,addr+=lineoffset) { 
            *addr++ &= *sprite >> mask1; 
            for (loop=1;loop<bytewidth;loop++) { 
               *addr &= ((*sprite++) << mask2); 
               *addr++ &= (*sprite >> mask1); 
            } 
            *addr &= (*sprite++ << mask2); 
        } 
    } else { 
        for (;h;h--,addr+=lineoffset) { 
            for (loop=0;loop<bytewidth;loop++) *addr++ &= *sprite++;
        } 
    }
}

void SpriteX8_xor(short x,short y,short h,unsigned char* sprite,short bytewidth,void* dest) {
    register unsigned char* addr  = ((unsigned char*)dest)+(CURRENT_INCY*y+(x>>3));
    register unsigned short mask1 = x & 7; 
    register unsigned short mask2; 
    register unsigned short lineoffset = CURRENT_INCY-bytewidth; 
    register          short loop; 
    if (mask1) { 
        mask2 = 8 - mask1; 
        for (;h;h--,addr+=lineoffset) { 
            *addr++ ^= *sprite >> mask1; 
            for (loop=1;loop<bytewidth;loop++) { 
               *addr ^= ((*sprite++) << mask2); 
               *addr++ ^= (*sprite >> mask1); 
            } 
            *addr ^= (*sprite++ << mask2); 
        } 
    } else { 
        for (;h;h--,addr+=lineoffset) { 
            for (loop=0;loop<bytewidth;loop++) *addr++ ^= *sprite++;
        } 
    }
}
void BitmapPutt (short x, short y,  void *bitmap, SCR_RECT *clip, short Attr, void* CURRENT_SCREEN)
{
		PortSet(CURRENT_SCREEN,239,127);
short* BitMap=bitmap;
	SCR_RECT	r;
	short	h, w;
	h = *(BitMap++);
	w = *(BitMap++);
	
	r.xy.x0 = x;
	r.xy.y0 = y;
	r.xy.y1 = y + h-1;
	r.xy.x1 = x + w-1;
	
	switch (Attr)
	{
	case	A_REVERSE:
DrawGrayRect(x,y,(*((unsigned short*)bitmap))+x,(*((unsigned short*)bitmap+1))+y,COLOR_BLACK,1);
	//	ScrRectFill(&r, clip, A_NORMAL);	
	case	A_XOR:
		SpriteX8_xor(x, y, h, (unsigned char *) BitMap, ((w-1)>>3)+1, CURRENT_SCREEN);
		break;
	case	A_REPLACE:
	//DrawGrayRect(x,y,(*((unsigned short*)bitmap))+x,(*((unsigned short*)bitmap+1))+y,COLOR_WHITE,1);
ScrRectFill(&r,clip,A_REVERSE);
	case	A_NORMAL:
	case	A_OR:
		SpriteX8_or(x, y, h, (unsigned char *) BitMap, ((w-1)>>3)+1, CURRENT_SCREEN);
		break;	
	case	A_AND:
		SpriteX8_and(x, y, h, (unsigned char *) BitMap, ((w-1)>>3)+1, CURRENT_SCREEN);
	default:
		break;
	}
}