// Header File
// Created 10/5/2003; 9:14:53 AM

#define DEFAULT 0

#define NOBORDER 1

#define INTS_DEF volatile INT_HANDLER __oldint1;\
volatile INT_HANDLER __oldint5;

#define INTS_PREPARE __oldint1=GetIntVec (AUTO_INT_1);\
__oldint5=GetIntVec (AUTO_INT_5);\
SetIntVec(AUTO_INT_1,DUMMY_HANDLER);\
SetIntVec(AUTO_INT_5,MyInt5);

#define INTS_DEACTIVATE SetIntVec(AUTO_INT_1,__oldint1);\
SetIntVec(AUTO_INT_5,__oldint5);


#define FONT_DEF short __oldfont;
#define FONT_INIT __oldfont=FontSetSys(F_4x6);

#define FONT_RESTORE FontSetSys(__oldfont);


#define GRAY_START GrayOnThrow();

#define GRAY_END GrayOff();


#define INIT_FUNCS(starter) {	\
	object* index=starter.objectset;\
	while(index->next){\
	  if(index->initiate)\
		index->initiate(index);\
		index=(object*)index->next;\
	}\
	index->initiate(index);}

#define CREATE_BEGINING(name,next,data) extern icon_dat data; \
object name##titlebar={{0,0},{0,7},{NO_DATA},{0,0},init_titlebar,titlebar_func,SPEC_BLANK_ACTION,SPEC_BLANK_ACTION,BLANK_ACTION,(next),NO_DATA,WINDOWPARENT};\
object name##close_box = {{0,0},{0,0},{NO_DATA},{0,0},init_close_box,close_window,BLANK_ACTION,BLANK_ACTION,BLANK_ACTION,&(name##titlebar),NO_DATA,WINDOWPARENT}; object name ={{0,0},{0,0},{},{0,0},icon,BLANK_ACTION,BLANK_ACTION,BLANK_ACTION,BLANK_ACTION,&(name##close_box),&data,WINDOWPARENT}; icon_dat data={8,8,

#define NO_ICON {0,8,0,8,0,0,0,0,0,0,0,0,0,8,0,8,0,0,0,0,0,0,0,0}

#define NO_DATA 0

#define LAST_OBJECT 0

#define WINDOW_EXISTS(name) extern window name;

#define WINDOW(name,x,y,x1,y1,title,initfunc,endfunc,objectset) }; window name = {{x,y},{x1,y1},title,initfunc,endfunc,objectset};

#define STARTCHUNK(name,x,y,x1,y1,initfunc,objectset) start_chunk name = {{x,y},{x1,y1},initfunc,objectset};


#define CLEAR_SCREEN ClearGrayScreen();
#define INITIALIZE_SYSTEM \
	/*CLEAR_SCREEN*/\
	\
	FONT_INIT\
	\
	INTS_PREPARE\
	\
	GRAY_START
	
#define END_SYSTEM \
	\
	GRAY_END\
	\
	INTS_DEACTIVATE\
	\
	FONT_RESTORE
	
#define INIT_DEFINES \
	INTS_DEF\
	\
	FONT_DEF

#define FREE_ALL \
({int i;for(i=0;i<num_allocated;i++)free(allocated[i]);});

#define INIT_MULTITASKING \
	if (EnableMultitasking(AUTO_INT_1)!=MT_OK) {END_SYSTEM return;}

#define END_MULTITASK \
  DisableMultitasking();

#define OBJECT_EXISTS(name) extern object name;

#define FUNCTION(function) allocated[num_allocated++]=malloc(sizeof(PROCESSCONTEXT)),function,allocated[num_allocated++]=(long*)malloc(1024),1024

#define BLANK_ACTION 0

#define SPEC_BLANK_ACTION ((void*)5)

#define NO_COORDINATE {0,0}
#define NO_TEXT {}

#define IS_ACTIVE(menu) (menu->active)
#define ACCESS(menu,num) (menu->items[num])



void redraw_all_chunks(void);

#define UNESTABLISH_WINDOW(wind) close_window(((window*)wind)->objectset)

#define REDRAW_ALL {redraw_all_windows(); redraw_all_chunks();}


#define ERRORCODE 1
#define NO_RESULT 0
#define NO 1
#define YES 2
#define QUIT 3

#define CHECK 1
#define NOCHECK 0