// Header File
// Created 2/27/2004; 12:22:25 AM
window* windowlist[10]={0};
unsigned short windowcount=0;
unsigned char close_light[8]={    0x88,0x50,0x20,0x50,
    0x88,0x00,0x00,0x00};
unsigned char close_dark[8]={    0x74,0xAC,0xDC,0xAC,
    0x74,0xFC,0x00,0x00};
unsigned char close_blank[8]={0b00000011,0b00000011,0b00000011,0b00000011,0b00000011,0b00000011,0b00000011,0b00000011};
unsigned short CheckWindowBounds(unsigned char x,unsigned char y,unsigned char x1,unsigned char y1,char* titlebar)
{
	if((unsigned)x1-x<(unsigned)((strlen(titlebar)*5)+8))
		return ERRORCODE;
	if(y1-y<11)
		return ERRORCODE;
	return 0;
}
void DrawOutline(short style,unsigned char x,unsigned char y,unsigned char x1,unsigned char y1)
{
if(style){
	DrawGrayRect(x,y,x1,y1,COLOR_LIGHTGRAY,1);
	DrawGrayLine(x,y,x1,y,COLOR_LIGHTGRAY);
	DrawGrayLine(x1-1,y,x1-1,y1-1,COLOR_DARKGRAY);
	DrawGrayLine(x,y+1,x,y1,COLOR_DARKGRAY);
	DrawGrayLine(x,y1-1,x1-1,y1-1,COLOR_DARKGRAY);
	DrawGrayLine(x+1,y1,x1,y1,COLOR_BLACK);
	DrawGrayLine(x1,y,x1,y1,COLOR_BLACK);
	DrawGrayRect(x,y+1,x1-2,y+9,COLOR_DARKGRAY,1);}
	else {
	DrawGrayRect(x+1,y+2,x1-1,y1-2,COLOR_LIGHTGRAY,1);
	DrawGrayLine(x+2,y1-1,x1-1,y1-1,COLOR_LIGHTGRAY);
	
	DrawGrayRect(x+1,y+2,x1-1,y+9,COLOR_DARKGRAY,1);
	DrawGrayLine(x+2,y+1,x1-1,y+1,COLOR_DARKGRAY);
	DrawGrayLine(x,y+2,x+2,y,COLOR_DARKGRAY);//upperleft corner
	DrawGrayLine(x+2,y,x1-2,y,COLOR_DARKGRAY);//top side
	DrawGrayLine(x1-2,y,x1,y+2,COLOR_DARKGRAY);//upperright corner
	DrawGrayLine(x1,y+2,x1,y1-2,COLOR_DARKGRAY);//right side
	DrawGrayLine(x1-2,y1,x1,y1-2,COLOR_DARKGRAY);//lowerright corner
	DrawGrayLine(x+2,y1,x1-2,y1,COLOR_DARKGRAY);//bottom side
	DrawGrayLine(x,y+2,x,y1-2,COLOR_DARKGRAY);//left side
	DrawGrayLine(x,y1-2,x+2,y1,COLOR_DARKGRAY);//lowerleft corner

	}
//	DrawGrayRect(x,y,x1,y+9,COLOR_DARKGRAY,0);
//	DrawGrayRect(x+1,y,x1,y+8,COLOR_LIGHTGRAY,1);
//	DrawGrayRect(x,y,x1,y1,COLOR_DARKGRAY,0);
}
void DrawTitleBar(unsigned char x,unsigned char y,unsigned char x1,unsigned char y1,char* titlebar)
{
//	PortSet (GrayGetPlane(DARK_PLANE), 239, 127);
//	DrawStr(8+x+1,y+2,titlebar,A_REPLACE);

//	PortSet (GrayGetPlane(LIGHT_PLANE), 239, 127);
//	DrawStr(8+x+1,y+2,titlebar,A_NORMAL);

	PortSet (GrayGetPlane(DARK_PLANE), 239, 127);
	DrawStr(8+x+1,y+2,titlebar,A_REVERSE);
		



}

short IS_ESTABLISHED(void* wind)
{
	window* win=wind;
	short i=0;
	for(i=0;i<windowcount;i++)
		if(windowlist[i]==wind)
			return 1;
	return 0;
}


extern char mouse_buffer[50];
extern char mouse_bufferd[50];
extern short mouse_x;
extern short mouse_y;
extern SCR_RECT mouse_loc;
void redraw_all_windows(void)
{
	ClearGrayScreen();
	short i;
	window* windowset;
	for(i=windowcount-1;i>-1;i--)
	{
		windowset=(windowlist[i]);
		DrawOutline(windowset->style,windowset->uppercorner.x,windowset->uppercorner.y,windowset->lowercorner.x,windowset->lowercorner.y);
		DrawTitleBar(windowset->uppercorner.x,windowset->uppercorner.y,windowset->lowercorner.x,windowset->lowercorner.y,windowset->title);
		INIT_FUNCS((*(windowlist[i])));
	}
}
void redraw_window(window* wind)
{
	BitmapPutt(mouse_x,mouse_y,mouse_buffer,&mouse_loc,A_REPLACE,GrayGetPlane(LIGHT_PLANE));
	BitmapPutt(mouse_x,mouse_y,mouse_bufferd,&mouse_loc,A_REPLACE,GrayGetPlane(DARK_PLANE));
	DrawOutline(wind->style,wind->uppercorner.x,wind->uppercorner.y,wind->lowercorner.x,wind->lowercorner.y);
	DrawTitleBar(wind->uppercorner.x,wind->uppercorner.y,wind->lowercorner.x,wind->lowercorner.y,wind->title);
	INIT_FUNCS((*(wind)));
	BitmapGettt(&mouse_loc,mouse_buffer,GrayGetPlane(LIGHT_PLANE));
	BitmapGettt(&mouse_loc,mouse_bufferd,GrayGetPlane(DARK_PLANE));
}
short get_wind_ind(window* wind)
{
	int i;
	for(i=0;i<windowcount;i++)
		if(windowlist[i]==wind)
			return i;
	return 0;
}
short WINDOW_FOUND(window* findme)
{
	short found=0;
	unsigned short i=0;
	for(;i<windowcount;i++)
		if(windowlist[i]==findme)
			return 1;
	return 0;
}
void close_window(void* window_to_close)
{
	object* saveit=window_to_close;
	window* shutwindow=saveit->parent;
	if(!WINDOW_FOUND(shutwindow))
		return;
	unsigned short i;
	for(i=get_wind_ind(shutwindow);i<windowcount;i++)
		windowlist[i]=windowlist[i+1];
	windowcount--;
	if(shutwindow->end_func)
		shutwindow->end_func(saveit);
	REDRAW_ALL;
}


void init_close_box(void* object_to_init)
{
	object* closebox=object_to_init;
	window* window_to_init_close=closebox->parent;
	Sprite8(window_to_init_close->lowercorner.x-7,window_to_init_close->uppercorner.y+2,6,close_blank,GrayGetPlane(LIGHT_PLANE),SPRT_AND);
	Sprite8(window_to_init_close->lowercorner.x-7,window_to_init_close->uppercorner.y+2,6,close_blank,GrayGetPlane(DARK_PLANE),SPRT_AND);
	Sprite8(window_to_init_close->lowercorner.x-7,window_to_init_close->uppercorner.y+2,6,close_light,GrayGetPlane(LIGHT_PLANE),SPRT_OR);
	Sprite8(window_to_init_close->lowercorner.x-7,window_to_init_close->uppercorner.y+2,6,close_dark,GrayGetPlane(DARK_PLANE),SPRT_OR);
	closebox->first.x=window_to_init_close->lowercorner.x-window_to_init_close->uppercorner.x-10;
	closebox->first.y=0;
	closebox->second.x=window_to_init_close->lowercorner.x-window_to_init_close->uppercorner.x-1;
	closebox->second.y=7;
}

void closewindow(void* closeme)
{
	ClearGrayScreen();
}

short activate(window* activate)
{
	int i;
	int ind;
	if(windowlist[0]==activate)
	{
		return 0;
	}
	for(i=0;windowlist[i]!=activate;i++);
	ind=i;
	for(i=ind-1;i>0;i--)
		windowlist[i+1]=windowlist[i];windowlist[1]=windowlist[0];
	windowlist[0]=activate;
	REDRAW_ALL;
	BitmapGettt(&mouse_loc,mouse_buffer,GrayGetPlane(LIGHT_PLANE));
	BitmapGettt(&mouse_loc,mouse_bufferd,GrayGetPlane(DARK_PLANE));
	return 1;
}

unsigned short ESTABLISH_WINDOW(window* windows)
{
	if(IS_ESTABLISHED(windows))
	{
		redraw_window(windows);
		return ERRORCODE;
	}
	windowlist[windowcount++]=windows;
	window windowset=*windows;
	if(CheckWindowBounds(windowset.uppercorner.x,windowset.uppercorner.y,windowset.lowercorner.x,windowset.lowercorner.y,windowset.title)==ERRORCODE)
		return ERRORCODE;
	if(windows->init_func)
		windows->init_func(windows);
	//DrawOutline(windowset.style,windowset.uppercorner.x,windowset.uppercorner.y,windowset.lowercorner.x,windowset.lowercorner.y);
	//DrawTitleBar(windowset.uppercorner.x,windowset.uppercorner.y,windowset.lowercorner.x,windowset.lowercorner.y,windowset.title);
	activate(windows);
	return 0;
}