// Header File
// Created 2/27/2004; 12:14:05 AM

typedef struct{
	unsigned char x;
	unsigned char y;
}coordinate;
typedef struct{
	coordinate first;
	coordinate second;
	char text[100];
	coordinate text_loc;
	void (*initiate)(void*);
	void (*function)(void*);
	void (*while_pressed)(void*);
	void (*not_pressed)(void*);
	void (*mouse_over)(void*);
	void *next;
	void *data;
	void *parent;
	char forecolor;
	char fontcolor;
	char bordercolor;
	char border;
	char fontsize;
	void *prev;
	char isover;
	char spacer;
}object;
typedef struct{
	coordinate uppercorner;
	coordinate lowercorner;
	char title[30];
	void (*init_func)(void*);
	void (*end_func)(void*);
	object* objectset;
	short style;
}window;
typedef struct{
	coordinate uppercorner;
	coordinate lowercorner;
	void (*init_func)(void*);
	object* objectset;
}start_chunk;
typedef struct{
	object* items[10];
	unsigned short num_items;
	unsigned short result;
	unsigned short active;
	void* userdata;
}menu;
typedef struct{
	unsigned short sizex;
	unsigned short sizey;
	char datalightdark[];
	//char datadark[1004];
}icon_dat;
typedef struct{
	void (*function)(void*);
	short time_out_val;
	long long init_val;
	void* next;
	short exec;
}timeout;
typedef struct{
	char datalight[12];
	char datadark[12];
	unsigned short result;
}checkbox_dat;
typedef struct{
	void* userdata;
	char datalightdark[];
}gfx_dat;
typedef struct{
	short num;
	menu* items[];
}toolbarlist;